package com.landray.kmss.sys.attachment.borrow.model;

import com.landray.kmss.util.StringUtil;
import com.landray.kmss.util.ArrayUtil;
import com.landray.kmss.common.convertor.ModelConvertor_ModelListToString;
import com.landray.kmss.common.convertor.IModelToFormConvertor;
import com.landray.kmss.common.convertor.ModelConvertor_Common;
import com.landray.kmss.sys.attachment.borrow.forms.SysAttBorrowForm;
import com.landray.kmss.sys.attachment.forms.AttachmentDetailsForm;
import java.util.ArrayList;
import com.landray.kmss.util.AutoHashMap;
import com.landray.kmss.sys.lbpmservice.interfaces.LbpmProcessForm;
import com.landray.kmss.sys.organization.model.SysOrgElement;
import java.util.List;
import java.util.Date;
import com.landray.kmss.common.convertor.ModelToFormPropertyMap;
import com.landray.kmss.sys.lbpmservice.interfaces.ISysLbpmMainModel;
import com.landray.kmss.sys.right.interfaces.ExtendAuthModel;

public class SysAttBorrow extends ExtendAuthModel implements ISysLbpmMainModel
{
    private static final long serialVersionUID = 1L;
    private static ModelToFormPropertyMap toFormPropertyMap;
    private Date fdBorrowEffectiveTime;
    private Date fdBorrowExpireTime;
    private Long fdDuration;
    private String fdReason;
    private Boolean fdReadEnable;
    private Boolean fdDownloadEnable;
    private Boolean fdCopyEnable;
    private Boolean fdPrintEnable;
    private String fdStatus;
    public static final String STATUS_UNDO = "0";
    public static final String STATUS_DOING = "1";
    public static final String STATUS_DONE = "2";
    public static final String STATUS_CLOSE = "3";
    private String fdAttId;
    private String docSubject;
    private List<SysOrgElement> fdBorrowers;
    private LbpmProcessForm sysWfBusinessModel;
    private AutoHashMap attachmentForms;
    
    public SysAttBorrow() {
        this.fdBorrowers = new ArrayList<SysOrgElement>();
        this.sysWfBusinessModel = new LbpmProcessForm();
        this.attachmentForms = new AutoHashMap((Class)AttachmentDetailsForm.class);
    }
    
    public Class<SysAttBorrowForm> getFormClass() {
        return SysAttBorrowForm.class;
    }
    
    public ModelToFormPropertyMap getToFormPropertyMap() {
        if (SysAttBorrow.toFormPropertyMap == null) {
            (SysAttBorrow.toFormPropertyMap = new ModelToFormPropertyMap()).putAll(super.getToFormPropertyMap());
            SysAttBorrow.toFormPropertyMap.put("docCreateTime", (IModelToFormConvertor)new ModelConvertor_Common("docCreateTime").setDateTimeType("datetime"));
            SysAttBorrow.toFormPropertyMap.put("fdBorrowEffectiveTime", (IModelToFormConvertor)new ModelConvertor_Common("fdBorrowEffectiveTime").setDateTimeType("datetime"));
            SysAttBorrow.toFormPropertyMap.addNoConvertProperty("authReaderFlag");
            SysAttBorrow.toFormPropertyMap.addNoConvertProperty("authEditorFlag");
            SysAttBorrow.toFormPropertyMap.put("docCreator.fdName", "docCreatorName");
            SysAttBorrow.toFormPropertyMap.put("docCreator.fdId", "docCreatorId");
            SysAttBorrow.toFormPropertyMap.put("fdBorrowers", (IModelToFormConvertor)new ModelConvertor_ModelListToString("fdBorrowerIds:fdBorrowerNames", "fdId:fdName"));
            SysAttBorrow.toFormPropertyMap.put("authReaders", (IModelToFormConvertor)new ModelConvertor_ModelListToString("authReaderIds:authReaderNames", "fdId:fdName"));
            SysAttBorrow.toFormPropertyMap.put("authEditors", (IModelToFormConvertor)new ModelConvertor_ModelListToString("authEditorIds:authEditorNames", "fdId:fdName"));
        }
        return SysAttBorrow.toFormPropertyMap;
    }
    
    public void recalculateFields() {
        super.recalculateFields();
        if (!this.getAuthReaderFlag()) {
            ArrayUtil.concatTwoList((List)this.getFdBorrowers(), this.authAllReaders);
            ArrayUtil.concatTwoList((List)this.getFdBorrowers(), this.authAllEditors);
            if (this.getDocCreator() != null && !this.authAllEditors.contains(this.getDocCreator())) {
                this.authAllEditors.add(this.getDocCreator());
            }
            final String status = this.getDocStatus();
            if (StringUtil.isNotNull(status) && status.charAt(0) >= '3') {
                ArrayUtil.concatTwoList((List)this.getFdBorrowers(), this.authAllReaders);
                ArrayUtil.concatTwoList((List)this.getFdBorrowers(), this.authAllEditors);
                if (this.getDocCreator() != null && !this.authAllEditors.contains(this.getDocCreator())) {
                    this.authAllEditors.add(this.getDocCreator());
                }
            }
        }
    }
    
    public Date getFdBorrowExpireTime() {
        return this.fdBorrowExpireTime;
    }
    
    public void setFdBorrowExpireTime(final Date fdBorrowExpireTime) {
        this.fdBorrowExpireTime = fdBorrowExpireTime;
    }
    
    public String getFdStatus() {
        return this.fdStatus;
    }
    
    public void setFdStatus(final String fdStatus) {
        this.fdStatus = fdStatus;
    }
    
    public Date getFdBorrowEffectiveTime() {
        return this.fdBorrowEffectiveTime;
    }
    
    public void setFdBorrowEffectiveTime(final Date fdBorrowEffectiveTime) {
        this.fdBorrowEffectiveTime = fdBorrowEffectiveTime;
    }
    
    public Long getFdDuration() {
        return this.fdDuration;
    }
    
    public void setFdDuration(final Long fdDuration) {
        this.fdDuration = fdDuration;
    }
    
    public String getFdReason() {
        return this.fdReason;
    }
    
    public void setFdReason(final String fdReason) {
        this.fdReason = fdReason;
    }
    
    public Boolean getFdReadEnable() {
        return this.fdReadEnable;
    }
    
    public void setFdReadEnable(final Boolean fdReadEnable) {
        this.fdReadEnable = fdReadEnable;
    }
    
    public Boolean getFdDownloadEnable() {
        return this.fdDownloadEnable;
    }
    
    public void setFdDownloadEnable(final Boolean fdDownloadEnable) {
        this.fdDownloadEnable = fdDownloadEnable;
    }
    
    public Boolean getFdCopyEnable() {
        return this.fdCopyEnable;
    }
    
    public void setFdCopyEnable(final Boolean fdCopyEnable) {
        this.fdCopyEnable = fdCopyEnable;
    }
    
    public Boolean getFdPrintEnable() {
        return this.fdPrintEnable;
    }
    
    public void setFdPrintEnable(final Boolean fdPrintEnable) {
        this.fdPrintEnable = fdPrintEnable;
    }
    
    public String getFdAttId() {
        return this.fdAttId;
    }
    
    public void setFdAttId(final String fdAttId) {
        this.fdAttId = fdAttId;
    }
    
    public String getDocSubject() {
        return this.docSubject;
    }
    
    public void setDocSubject(final String docSubject) {
        this.docSubject = docSubject;
    }
    
    public List<SysOrgElement> getFdBorrowers() {
        return this.fdBorrowers;
    }
    
    public void setFdBorrowers(final List<SysOrgElement> fdBorrowers) {
        this.fdBorrowers = fdBorrowers;
    }
    
    public Boolean getAuthReaderFlag() {
        return false;
    }
    
    public LbpmProcessForm getSysWfBusinessModel() {
        return this.sysWfBusinessModel;
    }
    
    public AutoHashMap getAttachmentForms() {
        return this.attachmentForms;
    }
}
